'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _dataField = require('./data-fields/data-field');

var _dataField2 = _interopRequireDefault(_dataField);

var _mutableGridList = require('./mutable-grid-list');

var _mutableGridList2 = _interopRequireDefault(_mutableGridList);

var _actionButton = require('./action-button');

var _actionButton2 = _interopRequireDefault(_actionButton);

var _baseSubheader = require('./base-subheader');

var _baseSubheader2 = _interopRequireDefault(_baseSubheader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function isNullOrUndefined(x) {
  return !(x != null);
}

var Adder = function (_React$Component) {
  _inherits(Adder, _React$Component);

  function Adder(props) {
    _classCallCheck(this, Adder);

    var _this = _possibleConstructorReturn(this, (Adder.__proto__ || Object.getPrototypeOf(Adder)).call(this, props));

    _this.state = { selectedItem: null };
    _this.onItemSelect = _this.onItemSelect.bind(_this);
    _this.onAddTouchTap = _this.onAddTouchTap.bind(_this);
    return _this;
  }

  _createClass(Adder, [{
    key: 'onItemSelect',
    value: function onItemSelect(docField, value) {
      this.setState({ selectedItem: value });
    }
  }, {
    key: 'onAddTouchTap',
    value: function onAddTouchTap() {
      var _this2 = this;

      var _props = this.props,
          addAction = _props.addAction,
          valueKey = _props.valueKey,
          initialItems = _props.initialItems,
          storeFunction = _props.storeFunction;

      if (addAction && !isNullOrUndefined(this.state.selectedItem)) {
        var index = (0, _lodash.findIndex)(initialItems, function (item) {
          return item[valueKey] === _this2.state.selectedItem;
        });
        addAction(storeFunction(initialItems[index]));
        this.setState({ selectedItem: null });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          initialItems = _props2.initialItems,
          value = _props2.value,
          tileAction = _props2.tileAction,
          displayName = _props2.displayName,
          storageType = _props2.storageType,
          gridDisplayKey = _props2.gridDisplayKey,
          selectDisplayConverter = _props2.selectDisplayConverter,
          selectFilterFunction = _props2.selectFilterFunction;

      var items = initialItems.map(selectDisplayConverter);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { className: 'row middle-xs' },
          _react2.default.createElement(
            'div',
            { className: 'col-xs-8 col-sm-8 col-md-8 col-lg-8' },
            _react2.default.createElement(_dataField2.default, {
              type: 'FILTER_SELECT',
              docField: 'selectedItem',
              displayName: displayName,
              value: this.state.selectedItem,
              onChange: this.onItemSelect,
              initialArray: items,
              filterArray: value,
              filterFunction: selectFilterFunction
            })
          ),
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_actionButton2.default, { type: 'ADD', onTouchTap: this.onAddTouchTap })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { marginTop: '0.3em' } },
          _react2.default.createElement(
            _baseSubheader2.default,
            null,
            'Selected'
          ),
          _react2.default.createElement(_mutableGridList2.default, {
            cellHeight: 60,
            values: value || [],
            action: tileAction,
            type: storageType,
            gridDisplayKey: gridDisplayKey
          })
        )
      );
    }
  }]);

  return Adder;
}(_react2.default.Component);

exports.default = Adder;


Adder.propTypes = {
  initialItems: _react2.default.PropTypes.array,
  value: _react2.default.PropTypes.array,
  addAction: _react2.default.PropTypes.func,
  tileAction: _react2.default.PropTypes.func,
  displayName: _react2.default.PropTypes.string,
  selectFilterFunction: _react2.default.PropTypes.func,
  storageType: _react2.default.PropTypes.string,
  gridDisplayKey: _react2.default.PropTypes.string,
  valueKey: _react2.default.PropTypes.string,
  selectDisplayConverter: _react2.default.PropTypes.func,
  storeFunction: _react2.default.PropTypes.func
};