'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _reactCodemirror = require('react-codemirror');

var _reactCodemirror2 = _interopRequireDefault(_reactCodemirror);

require('codemirror/mode/javascript/javascript');

require('codemirror/theme/monokai.css');

require('../../styles/code-mirror.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CodeMirrorDataField = function (_React$Component) {
  _inherits(CodeMirrorDataField, _React$Component);

  function CodeMirrorDataField(props) {
    _classCallCheck(this, CodeMirrorDataField);

    var _this = _possibleConstructorReturn(this, (CodeMirrorDataField.__proto__ || Object.getPrototypeOf(CodeMirrorDataField)).call(this, props));

    _this.onCodeChanges = _this.onCodeChanges.bind(_this);
    _this.editorRefCallback = _this.editorRefCallback.bind(_this);
    return _this;
  }

  _createClass(CodeMirrorDataField, [{
    key: 'onCodeChanges',
    value: function onCodeChanges(value) {
      this.props.onChange(this.props.docField, value);
    }
  }, {
    key: 'editorRefCallback',
    value: function editorRefCallback(ref) {
      if (ref) {
        var cm = ref.getCodeMirror();

        var _ref = this.props || '',
            width = _ref.width,
            height = _ref.height;

        width = width || 200;
        height = height || 200;
        cm.setSize(width, height);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          displayName = _props.displayName,
          value = _props.value,
          readOnly = _props.readOnly;

      var options = {
        lineNumbers: true,
        mode: 'javascript',
        lineWrapping: false,
        readOnly: readOnly || false
      };
      var codeFieldValue = (0, _lodash.isNull)(value) || (0, _lodash.isUndefined)(value) ? '' : value;
      return _react2.default.createElement(
        'div',
        { style: { margin: '20px 0px' } },
        _react2.default.createElement(
          'label',
          {
            style: {
              fontFamily: 'Roboto, sans-serif',
              fontSize: '12px',
              color: 'rgba(0, 0, 0, 0.498039)'
            }
          },
          displayName
        ),
        _react2.default.createElement(
          'div',
          { style: { margin: '10px 0px' } },
          _react2.default.createElement(_reactCodemirror2.default, {
            ref: this.editorRefCallback,
            value: codeFieldValue,
            options: options,
            onChange: this.onCodeChanges
          })
        )
      );
    }
  }]);

  return CodeMirrorDataField;
}(_react2.default.Component);

CodeMirrorDataField.propTypes = {
  onChange: _react2.default.PropTypes.any,
  docField: _react2.default.PropTypes.any,
  displayName: _react2.default.PropTypes.any,
  value: _react2.default.PropTypes.any,
  readOnly: _react2.default.PropTypes.any
};

exports.default = CodeMirrorDataField;