'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _AutoComplete = require('material-ui/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _reactSimpleDi = require('react-simple-di');

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CodeValueField = function (_Field) {
  _inherits(CodeValueField, _Field);

  function CodeValueField(props) {
    _classCallCheck(this, CodeValueField);

    var _this = _possibleConstructorReturn(this, (CodeValueField.__proto__ || Object.getPrototypeOf(CodeValueField)).call(this, props));

    _this.state = {
      values: [],
      codevalues: [],
      disabled: props.disabled ? props.disabled : false,
      errorText: _this.validateText(props.value ? props.value.value : ''),
      selectedCodeField: null
    };

    _this.onTextChange = _this.onTextChange.bind(_this);
    _this.handleUpdateInput = _this.handleUpdateInput.bind(_this);
    _this.updateData = _this.updateData.bind(_this);
    _this.handleNewRequest = _this.handleNewRequest.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.searchCodeValue = _this.searchCodeValue.bind(_this);
    _this.onFocus = _this.onFocus.bind(_this);
    return _this;
  }

  _createClass(CodeValueField, [{
    key: 'onTextChange',
    value: function onTextChange(textFieldValue) {
      var _props = this.props,
          onChange = _props.onChange,
          docField = _props.docField;

      this.setState({ selectedCodeField: { code: '', value: textFieldValue } });
      onChange(docField, this.searchCodeValue(textFieldValue));
    }
  }, {
    key: 'onFocus',
    value: function onFocus() {
      var selectedCodeField = this.state.selectedCodeField;

      if (!selectedCodeField || !selectedCodeField.value) {
        this.handleUpdateInput('');
      }
    }
  }, {
    key: 'searchCodeValue',
    value: function searchCodeValue(text) {
      var values = this.state.values;

      if (values.length === 0) {
        return { code: '', value: text };
      }

      var filteredResult = values.filter(function (val) {
        return val.code === text || val.value === text;
      });
      if (text && text.length > 0 && filteredResult && filteredResult.length > 0) {
        return filteredResult[0];
      }
      return { code: text, value: text };
    }
  }, {
    key: 'handleUpdateInput',
    value: function handleUpdateInput() {
      var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      var _this2 = this;

      var ds = arguments[1];
      var params = arguments[2];
      var _props2 = this.props,
          searchCodeValues = _props2.searchCodeValues,
          limit = _props2.limit,
          collection = _props2.collection;

      if (params && params.source === 'touchTap') {
        return;
      }
      if (searchCodeValues) {
        searchCodeValues(collection, limit, text, function (result) {
          _this2.updateData(result);
          _this2.onTextChange(text);
        });
      }
    }
  }, {
    key: 'updateData',
    value: function updateData(data) {
      var dataSource = [];
      data.forEach(function (codeValue) {
        dataSource.push({
          text: codeValue.value,
          value: _react2.default.createElement(_MenuItem2.default, {
            primaryText: codeValue.code,
            secondaryText: codeValue.value
          })
        });
      });
      this.setState({ codevalues: dataSource });
      var values = data.map(function (field) {
        return { code: field.code, value: field.value };
      });
      this.setState({ values: values });
    }
  }, {
    key: 'handleNewRequest',
    value: function handleNewRequest(chosenRequest, index) {
      var values = this.state.values;
      var _props3 = this.props,
          onItemSelect = _props3.onItemSelect,
          docField = _props3.docField;

      if (onItemSelect) {
        var newIndex = 0;
        if (index > -1) {
          newIndex = index;
        }
        this.setState({ selectedCodeField: values[newIndex] });
        onItemSelect(docField, values[newIndex]);
      }
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      var _props4 = this.props,
          onItemSelect = _props4.onItemSelect,
          docField = _props4.docField;

      if (this.state.codevalues.length === 0) {
        if (onItemSelect) {
          onItemSelect(docField, null);
          return;
        }
      }

      var codeValue = this.state.selectedCodeField || {};
      var value = this.state.values.find(function (element) {
        return element.value === codeValue.value;
      });
      if (!value && codeValue.value) {
        codeValue = this.state.values[0];
      }
      if (onItemSelect) {
        onItemSelect(docField, codeValue);
      }
    }
  }, {
    key: 'validateText',
    value: function validateText(text) {
      try {
        this.checkMandatory(text);
      } catch (error) {
        this.fieldIsInvalid();
        return error.message;
      }
      this.fieldIsValid();
      return '';
    }
  }, {
    key: 'filter',
    value: function filter(searchText, key, item) {
      var searchTextToUse = searchText ? searchText.toLowerCase() : '';
      return key.toLowerCase().includes(searchTextToUse) || item.value.props.primaryText.toLowerCase().includes(searchTextToUse);
    }
  }, {
    key: 'render',
    value: function render() {
      var disabled = this.props.disabled;

      var searchText = this.props.value ? this.props.value.value : '';
      var errorText = this.validateText(searchText);
      return _react2.default.createElement(_AutoComplete2.default, {
        floatingLabelText: this.props.displayName,
        filter: this.filter,
        dataSource: this.state.codevalues,
        onNewRequest: this.handleNewRequest,
        onUpdateInput: this.handleUpdateInput,
        openOnFocus: true,
        searchText: searchText || '',
        disabled: !!disabled,
        errorText: errorText,
        onBlur: this.handleBlur,
        onFocus: this.onFocus,
        fullWidth: true
      });
    }
  }]);

  return CodeValueField;
}(_field2.default);

CodeValueField.propTypes = {
  displayName: _react2.default.PropTypes.string,
  collection: _react2.default.PropTypes.string,
  limit: _react2.default.PropTypes.number,
  onChange: _react2.default.PropTypes.func,
  value: _react2.default.PropTypes.object,
  isRequired: _react2.default.PropTypes.bool,
  disabled: _react2.default.PropTypes.bool,
  docField: _react2.default.PropTypes.string,
  searchCodeValues: _react2.default.PropTypes.func,
  onItemSelect: _react2.default.PropTypes.func,
  onInvalid: _react2.default.PropTypes.func
};

var depsToProps = function depsToProps(context, actions) {
  return {
    searchCodeValues: actions.codeValueActions.searchCodeValues
  };
};

exports.default = (0, _reactSimpleDi.useDeps)(depsToProps)(CodeValueField);