'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _lodash = require('lodash');

var _timeDataField = require('./time-data-field');

var _timeDataField2 = _interopRequireDefault(_timeDataField);

var _textDataField = require('./text-data-field');

var _textDataField2 = _interopRequireDefault(_textDataField);

var _dateDataField = require('./date-data-field');

var _dateDataField2 = _interopRequireDefault(_dateDataField);

var _checkboxDataField = require('./checkbox-data-field');

var _checkboxDataField2 = _interopRequireDefault(_checkboxDataField);

var _selectDataField = require('./select-data-field');

var _selectDataField2 = _interopRequireDefault(_selectDataField);

var _filteredSelectDataFields = require('./filtered-select-data-fields');

var _filteredSelectDataFields2 = _interopRequireDefault(_filteredSelectDataFields);

var _passwordDataField = require('./password-data-field');

var _passwordDataField2 = _interopRequireDefault(_passwordDataField);

var _formulaDataField = require('./formula-data-field');

var _formulaDataField2 = _interopRequireDefault(_formulaDataField);

var _numberDataField = require('./number-data-field');

var _numberDataField2 = _interopRequireDefault(_numberDataField);

var _readOnlyTextField = require('./read-only-text-field');

var _readOnlyTextField2 = _interopRequireDefault(_readOnlyTextField);

var _codeMirrorDataField = require('./code-mirror-data-field');

var _codeMirrorDataField2 = _interopRequireDefault(_codeMirrorDataField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataField = function (_React$Component) {
  _inherits(DataField, _React$Component);

  function DataField() {
    _classCallCheck(this, DataField);

    return _possibleConstructorReturn(this, (DataField.__proto__ || Object.getPrototypeOf(DataField)).apply(this, arguments));
  }

  _createClass(DataField, [{
    key: 'getFieldType',
    value: function getFieldType() {
      if (this.props.type) {
        return this.props.type;
      } else if (this.props.schema) {
        return this.props.schema.type;
      }
      return 'READ_ONLY';
    }
  }, {
    key: 'createReadOnlyDataField',
    value: function createReadOnlyDataField() {
      return _react2.default.createElement(_readOnlyTextField2.default, this.props);
    }
  }, {
    key: 'createDateComponent',
    value: function createDateComponent() {
      var value = new Date(this.props.value);
      if (this.props.schema) {
        return _react2.default.createElement(_dateDataField2.default, _extends({
          value: value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_dateDataField2.default, _extends({ value: value }, this.props));
    }
  }, {
    key: 'createTextComponent',
    value: function createTextComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_textDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_textDataField2.default, this.props);
    }
  }, {
    key: 'createNumberDataField',
    value: function createNumberDataField() {
      if (this.props.schema) {
        return _react2.default.createElement(_numberDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_numberDataField2.default, this.props);
    }
  }, {
    key: 'createCodeMirrorComponent',
    value: function createCodeMirrorComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_codeMirrorDataField2.default, this.props.schema);
      }
      return _react2.default.createElement(_codeMirrorDataField2.default, this.props);
    }
  }, {
    key: 'createTimeComponent',
    value: function createTimeComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_timeDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_timeDataField2.default, this.props);
    }
  }, {
    key: 'createCheckboxComponent',
    value: function createCheckboxComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_checkboxDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_checkboxDataField2.default, this.props);
    }
  }, {
    key: 'createSelectComponent',
    value: function createSelectComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_selectDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_selectDataField2.default, this.props);
    }
  }, {
    key: 'createFilterSelectComponent',
    value: function createFilterSelectComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_filteredSelectDataFields2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_filteredSelectDataFields2.default, this.props);
    }
  }, {
    key: 'createPasswordComponent',
    value: function createPasswordComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_passwordDataField2.default, _extends({
          value: this.props.value
        }, this.props.schema, {
          onChange: this.props.onChange,
          disabled: this.props.disabled
        }));
      }
      return _react2.default.createElement(_passwordDataField2.default, this.props);
    }
  }, {
    key: 'createFormulaComponent',
    value: function createFormulaComponent() {
      if (this.props.schema) {
        return _react2.default.createElement(_formulaDataField2.default, _extends({}, this.props.schema, {
          disabled: true
        }));
      }
      return _react2.default.createElement(_formulaDataField2.default, this.props);
    }
  }, {
    key: 'createField',
    value: function createField() {
      var fieldType = this.getFieldType();
      switch ((0, _lodash.toUpper)(fieldType)) {
        case 'DATE':
          return this.createDateComponent();
        case 'TIME':
          return this.createTimeComponent();
        case 'BOOL':
          return this.createCheckboxComponent();
        case 'SELECT':
          return this.createSelectComponent();
        case 'FILTER_SELECT':
          return this.createFilterSelectComponent();
        case 'PASSWORD':
          return this.createPasswordComponent();
        case 'FORMULA':
          return this.createFormulaComponent();
        case 'NUMBER':
          return this.createNumberDataField();
        case 'TEXT':
          return this.createTextComponent();
        case 'CODE':
          return this.createCodeMirrorComponent();
        default:
          return this.createReadOnlyDataField();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.createField()
      );
    }
  }]);

  return DataField;
}(_react2.default.Component);

exports.default = DataField;


DataField.propTypes = {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool, _propTypes2.default.number, _propTypes2.default.object, _propTypes2.default.array]),
  docField: _propTypes2.default.string,
  displayName: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  menuItems: _propTypes2.default.array,
  disabled: _propTypes2.default.bool,
  type: _propTypes2.default.string,
  schema: _propTypes2.default.object
};