'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _lodash = require('lodash');

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormulaDataField = function (_Field) {
  _inherits(FormulaDataField, _Field);

  function FormulaDataField(props) {
    _classCallCheck(this, FormulaDataField);

    var _this = _possibleConstructorReturn(this, (FormulaDataField.__proto__ || Object.getPrototypeOf(FormulaDataField)).call(this, props));

    _this.calculateValue = _this.calculateValue.bind(_this);
    return _this;
  }

  _createClass(FormulaDataField, [{
    key: 'calculateValue',
    value: function calculateValue() {
      var _props = this.props,
          formula = _props.formula,
          dataObject = _props.dataObject;

      try {
        var formulaFunction = new Function(formula); // eslint-disable-line
        return formulaFunction.apply(dataObject);
      } catch (e) {
        console.log(e);
        return '';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          displayName = _props2.displayName,
          docField = _props2.docField,
          value = _props2.value,
          onChange = _props2.onChange,
          isRequired = _props2.isRequired,
          readOnly = _props2.readOnly,
          other = _objectWithoutProperties(_props2, ['displayName', 'docField', 'value', 'onChange', 'isRequired', 'readOnly']);

      var formulaValue = value;
      if (!readOnly) {
        formulaValue = this.calculateValue();
        if ((0, _lodash.isNaN)(formulaValue)) {
          formulaValue = undefined;
        }
      }
      return _react2.default.createElement(_TextField2.default, _extends({
        value: formulaValue,
        fullWidth: true,
        disabled: true,
        floatingLabelText: displayName
      }, other));
    }
  }]);

  return FormulaDataField;
}(_field2.default);

exports.default = FormulaDataField;


FormulaDataField.propTypes = {
  displayName: _react2.default.PropTypes.string,
  docField: _react2.default.PropTypes.string,
  formula: _react2.default.PropTypes.string,
  dataObject: _react2.default.PropTypes.object,
  value: _react2.default.PropTypes.any,
  formulaReturnType: _react2.default.PropTypes.string,
  readOnly: _react2.default.PropTypes.bool
};