'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _lodash = require('lodash');

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NumberDataField = function (_Field) {
  _inherits(NumberDataField, _Field);

  function NumberDataField(props) {
    _classCallCheck(this, NumberDataField);

    var _this = _possibleConstructorReturn(this, (NumberDataField.__proto__ || Object.getPrototypeOf(NumberDataField)).call(this, props));

    _this.state = {
      errorText: _this.validateText(props.value)
    };
    _this.onTextChange = _this.onTextChange.bind(_this);
    return _this;
  }

  _createClass(NumberDataField, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      this.setState({
        errorText: this.validateText(newProps.value, newProps)
      });
    }
  }, {
    key: 'onTextChange',
    value: function onTextChange(event) {
      var _props = this.props,
          onChange = _props.onChange,
          decimalPlaces = _props.decimalPlaces;

      event.preventDefault();
      var textFieldValue = this.refs.numberField.getValue();
      var errorText = this.validateText(textFieldValue);
      this.setState({
        errorText: errorText
      });
      onChange(this.props.docField, (0, _lodash.floor)(textFieldValue, decimalPlaces));
    }
  }, {
    key: 'validateText',
    value: function validateText(text, props) {
      try {
        this.checkMandatory(text, props);
        this.checkValidation(text, 'isDecimal');
        this.checkRange(text);
      } catch (error) {
        this.fieldIsInvalid();
        return error.message;
      }
      this.fieldIsValid();
      return '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          displayName = _props2.displayName,
          onChange = _props2.onChange,
          value = _props2.value,
          docField = _props2.docField,
          isRequired = _props2.isRequired,
          onInvalid = _props2.onInvalid,
          other = _objectWithoutProperties(_props2, ['displayName', 'onChange', 'value', 'docField', 'isRequired', 'onInvalid']);

      return _react2.default.createElement(_TextField2.default, _extends({
        value: value,
        onChange: this.onTextChange,
        fullWidth: true,
        ref: 'numberField',
        floatingLabelText: displayName,
        errorText: this.state.errorText
      }, other));
    }
  }]);

  return NumberDataField;
}(_field2.default);

exports.default = NumberDataField;


NumberDataField.propTypes = {
  displayName: _react2.default.PropTypes.string,
  value: _react2.default.PropTypes.any,
  docField: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  isRequired: _react2.default.PropTypes.bool,
  minValue: _react2.default.PropTypes.number,
  maxValue: _react2.default.PropTypes.number,
  decimalPlaces: _react2.default.PropTypes.number,
  onInvalid: _react2.default.PropTypes.func
};