'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _messages = require('../messages');

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PasswordDataField = function (_Field) {
  _inherits(PasswordDataField, _Field);

  function PasswordDataField(props) {
    _classCallCheck(this, PasswordDataField);

    var _this = _possibleConstructorReturn(this, (PasswordDataField.__proto__ || Object.getPrototypeOf(PasswordDataField)).call(this, props));

    _this.state = { errorText: _this.validateText(props.value) };
    _this.onTextChange = _this.onTextChange.bind(_this);
    return _this;
  }

  _createClass(PasswordDataField, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var value = newProps.value;

      this.setState({ errorText: this.validateText(value, newProps) });
    }
  }, {
    key: 'onTextChange',
    value: function onTextChange(event) {
      var onChange = this.props.onChange;

      event.preventDefault();
      var textFieldValue = this.refs.passwordField.getValue();
      this.setState({ errorText: this.validateText(textFieldValue) });
      onChange(this.props.docField, textFieldValue);
    }
  }, {
    key: 'validateText',
    value: function validateText(text, newProps) {
      var props = newProps || this.props;
      var isRequired = props.isRequired;

      if (isRequired !== false && ((0, _lodash.isNull)(text) || (0, _lodash.isUndefined)(text) || (0, _lodash.isEmpty)(text.trim()))) {
        return _messages.DisplayMessages.requiredText;
      }
      return '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          displayName = _props.displayName,
          isRequired = _props.isRequired,
          value = _props.value,
          docField = _props.docField,
          onChange = _props.onChange,
          other = _objectWithoutProperties(_props, ['displayName', 'isRequired', 'value', 'docField', 'onChange']); // eslint-disable-line no-unused-vars


      return _react2.default.createElement(_TextField2.default, _extends({
        value: value || '',
        onChange: this.onTextChange,
        ref: 'passwordField',
        fullWidth: true,
        floatingLabelText: displayName,
        type: 'password',
        errorText: this.state.errorText
      }, other));
    }
  }]);

  return PasswordDataField;
}(_field2.default);

exports.default = PasswordDataField;


PasswordDataField.propTypes = {
  displayName: _react2.default.PropTypes.string,
  value: _react2.default.PropTypes.any,
  docField: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  isRequired: _react2.default.PropTypes.bool
};