'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectDataField = function (_Field) {
  _inherits(SelectDataField, _Field);

  function SelectDataField(props) {
    _classCallCheck(this, SelectDataField);

    var _this = _possibleConstructorReturn(this, (SelectDataField.__proto__ || Object.getPrototypeOf(SelectDataField)).call(this, props));

    _this.handleChange = _this.handleChange.bind(_this);
    var value = _this.isValueAvailable(props.menuItems, props.value);
    _this.menus = [];
    var index = 0;
    props.menuItems.forEach(function (menu) {
      _this.menus.push(_react2.default.createElement(_MenuItem2.default, _extends({ key: index++ }, menu)));
    });
    _this.state = { errorText: _this.checkFieldSelected(value)
    };
    return _this;
  }

  _createClass(SelectDataField, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var _this2 = this;

      if (JSON.stringify(newProps.menuItems) !== JSON.stringify(this.props.menuItems)) {
        this.menus.length = 0;
        var index = 0;
        newProps.menuItems.forEach(function (menu) {
          _this2.menus.push(_react2.default.createElement(_MenuItem2.default, _extends({ key: index++ }, menu)));
        });
      }
      var value = this.isValueAvailable(this.props.menuItems, newProps.value);
      this.setState({ errorText: this.checkFieldSelected(value, newProps) });
    }
  }, {
    key: 'checkFieldSelected',
    value: function checkFieldSelected(value, newProps) {
      try {
        this.checkMandatory(value, newProps);
      } catch (error) {
        this.fieldIsInvalid();
        return error.message;
      }
      this.fieldIsValid();
      return null;
    }
  }, {
    key: 'isValueAvailable',
    value: function isValueAvailable(menuItems, value) {
      var returnedMenuItem = (0, _lodash.find)(menuItems, function (menuItem) {
        return menuItem.value === value;
      });
      return (0, _lodash.isUndefined)(returnedMenuItem) ? null : returnedMenuItem.value;
    }
  }, {
    key: 'handleChange',
    value: function handleChange(event, selectedIndex, value) {
      event.preventDefault();
      this.props.onChange(this.props.docField, value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          onChange = _props.onChange,
          docField = _props.docField,
          isRequired = _props.isRequired,
          menuItems = _props.menuItems,
          displayName = _props.displayName,
          other = _objectWithoutProperties(_props, ['value', 'onChange', 'docField', 'isRequired', 'menuItems', 'displayName']);

      return _react2.default.createElement(
        _SelectField2.default,
        _extends({
          value: value,
          floatingLabelText: displayName,
          onChange: this.handleChange,
          errorText: this.state.errorText,
          fullWidth: true
        }, other),
        this.menus
      );
    }
  }]);

  return SelectDataField;
}(_field2.default);

exports.default = SelectDataField;


SelectDataField.propTypes = {
  value: _react2.default.PropTypes.any,
  onChange: _react2.default.PropTypes.func,
  menuItems: _react2.default.PropTypes.array,
  docField: _react2.default.PropTypes.string,
  displayName: _react2.default.PropTypes.string,
  isRequired: _react2.default.PropTypes.bool
};