'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _lodash = require('lodash');

var _field = require('./field');

var _field2 = _interopRequireDefault(_field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextDataField = function (_Field) {
  _inherits(TextDataField, _Field);

  function TextDataField(props) {
    _classCallCheck(this, TextDataField);

    var _this = _possibleConstructorReturn(this, (TextDataField.__proto__ || Object.getPrototypeOf(TextDataField)).call(this, props));

    _this.onTextChange = _this.onTextChange.bind(_this);
    _this.onBlur = _this.onBlur.bind(_this);
    return _this;
  }

  _createClass(TextDataField, [{
    key: 'onBlur',
    value: function onBlur(event) {
      var _props = this.props,
          onChange = _props.onChange,
          docField = _props.docField;

      var textFieldValue = (0, _lodash.trim)(event.target.value);
      onChange(docField, textFieldValue);
    }
  }, {
    key: 'onTextChange',
    value: function onTextChange(event) {
      var _props2 = this.props,
          onChange = _props2.onChange,
          docField = _props2.docField;

      event.preventDefault();
      var textFieldValue = event.target.value;
      onChange(docField, textFieldValue);
    }
  }, {
    key: 'validateText',
    value: function validateText(text) {
      try {
        this.checkMandatory(text);
        this.checkValidation(text);
        this.checkRegex(text);
      } catch (error) {
        this.fieldIsInvalid();
        return error.message;
      }
      this.fieldIsValid();
      return '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          displayName = _props3.displayName,
          onChange = _props3.onChange,
          value = _props3.value,
          docField = _props3.docField,
          isRequired = _props3.isRequired,
          validatorType = _props3.validatorType,
          onInvalid = _props3.onInvalid,
          other = _objectWithoutProperties(_props3, ['displayName', 'onChange', 'value', 'docField', 'isRequired', 'validatorType', 'onInvalid']);

      var errorText = this.validateText(value);
      return _react2.default.createElement(_TextField2.default, _extends({
        value: value || '',
        onChange: this.onTextChange,
        onBlur: this.onBlur,
        fullWidth: true,
        ref: 'textField',
        floatingLabelText: displayName,
        errorText: errorText
      }, other));
    }
  }]);

  return TextDataField;
}(_field2.default);

exports.default = TextDataField;


TextDataField.propTypes = {
  displayName: _react2.default.PropTypes.string,
  value: _react2.default.PropTypes.any,
  docField: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  isRequired: _react2.default.PropTypes.bool,
  validatorType: _react2.default.PropTypes.string,
  onInvalid: _react2.default.PropTypes.func,
  validationRegex: _react2.default.PropTypes.string
};