'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Dialog = require('material-ui/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _actionButton = require('./action-button');

var _actionButton2 = _interopRequireDefault(_actionButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ImageDialog = function ImageDialog(_ref) {
  var open = _ref.open,
      name = _ref.name,
      url = _ref.url,
      onClose = _ref.onClose;

  var actions = [_react2.default.createElement(_actionButton2.default, {
    label: 'Ok',
    primary: true,
    onTouchTap: onClose,
    type: 'RAISED'
  })];
  var contentStyle = { height: '80%', maxHeight: 'none' };
  return _react2.default.createElement(
    _Dialog2.default,
    {
      title: name,
      actions: actions,
      open: open,
      onRequestClose: onClose,
      autoScrollBodyContent: true,
      contentStyle: contentStyle
    },
    _react2.default.createElement('img', { alt: 'Camera', src: url, height: 350, width: 500 })
  );
};

var PropTypes = _react2.default.PropTypes;

ImageDialog.propTypes = {
  open: PropTypes.bool,
  url: PropTypes.string,
  name: PropTypes.string,
  onClose: PropTypes.func
};

exports.default = ImageDialog;