'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _simpleGridList = require('./simple-grid-list');

var _simpleGridList2 = _interopRequireDefault(_simpleGridList);

var _simpleGridTile = require('./simple-grid-tile');

var _simpleGridTile2 = _interopRequireDefault(_simpleGridTile);

var _actionButton = require('./action-button');

var _actionButton2 = _interopRequireDefault(_actionButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MutableGridList = function (_React$Component) {
  _inherits(MutableGridList, _React$Component);

  function MutableGridList(props) {
    _classCallCheck(this, MutableGridList);

    var _this = _possibleConstructorReturn(this, (MutableGridList.__proto__ || Object.getPrototypeOf(MutableGridList)).call(this, props));

    _this.onGridTileAction = _this.onGridTileAction.bind(_this);
    return _this;
  }

  _createClass(MutableGridList, [{
    key: 'onGridTileAction',
    value: function onGridTileAction(val) {
      var _props = this.props,
          action = _props.action,
          values = _props.values,
          type = _props.type,
          gridDisplayKey = _props.gridDisplayKey;

      if (type === 'TEXT') {
        return function () {
          return action((0, _lodash.findIndex)(values, function (v) {
            return v === val;
          }));
        };
      }
      return function () {
        return action((0, _lodash.findIndex)(values, function (v) {
          return v[gridDisplayKey] === val;
        }));
      };
    }
  }, {
    key: 'renderGridTiles',
    value: function renderGridTiles(type, gridDisplayKey, values) {
      var _this2 = this;

      var index = 0;
      return values.map(function (val) {
        if (type === 'TEXT') {
          return _react2.default.createElement(_simpleGridTile2.default, {
            key: index++,
            title: val,
            titlePosition: 'top',
            titleBackground: 'rgba(96, 96, 96, 0.7)',
            actionIcon: _react2.default.createElement(_actionButton2.default, {
              type: 'ICON',
              icon: 'indeterminate_check_box',
              onTouchTap: _this2.onGridTileAction(val)
            })
          });
        }
        return _react2.default.createElement(_simpleGridTile2.default, {
          key: index++,
          title: val[gridDisplayKey],
          titlePosition: 'top',
          titleBackground: 'rgba(96, 96, 96, 0.7)',
          actionIcon: _react2.default.createElement(_actionButton2.default, {
            type: 'ICON',
            icon: 'indeterminate_check_box',
            onTouchTap: _this2.onGridTileAction(val[gridDisplayKey])
          })
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          values = _props2.values,
          action = _props2.action,
          type = _props2.type,
          gridDisplayKey = _props2.gridDisplayKey,
          other = _objectWithoutProperties(_props2, ['values', 'action', 'type', 'gridDisplayKey']);

      return _react2.default.createElement(
        _simpleGridList2.default,
        other,
        this.renderGridTiles(type, gridDisplayKey, values, action)
      );
    }
  }]);

  return MutableGridList;
}(_react2.default.Component);

exports.default = MutableGridList;


MutableGridList.propTypes = {
  values: _react2.default.PropTypes.array,
  action: _react2.default.PropTypes.func,
  gridDisplayKey: _react2.default.PropTypes.string,
  type: _react2.default.PropTypes.string
};