'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Popover = require('material-ui/Popover');

var _Popover2 = _interopRequireDefault(_Popover);

var _List = require('material-ui/List');

var _FontIcon = require('material-ui/FontIcon');

var _FontIcon2 = _interopRequireDefault(_FontIcon);

var _colors = require('material-ui/styles/colors');

var Colors = _interopRequireWildcard(_colors);

var _Avatar = require('material-ui/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Notification = function (_React$Component) {
  _inherits(Notification, _React$Component);

  function Notification(props) {
    _classCallCheck(this, Notification);

    var _this = _possibleConstructorReturn(this, (Notification.__proto__ || Object.getPrototypeOf(Notification)).call(this, props));

    _this.closePopover = _this.closePopover.bind(_this);
    return _this;
  }

  _createClass(Notification, [{
    key: 'getNotificationStyle',
    value: function getNotificationStyle() {
      return { width: '30em', height: '6em' };
    }
  }, {
    key: 'getNotificationFontIcon',
    value: function getNotificationFontIcon(notificationType) {
      switch (notificationType) {
        case 'Success':
          return _react2.default.createElement(
            _FontIcon2.default,
            { className: 'material-icons', color: 'white' },
            'check'
          );
        case 'Error':
          return _react2.default.createElement(
            _FontIcon2.default,
            { className: 'material-icons', color: 'white' },
            'clear'
          );
        case 'Info':
          return _react2.default.createElement(
            _FontIcon2.default,
            { className: 'material-icons', color: 'white' },
            'info'
          );
        case 'Warning':
          return _react2.default.createElement(
            _FontIcon2.default,
            { className: 'material-icons', color: 'white' },
            'warning'
          );
        default:
          return _react2.default.createElement(
            _FontIcon2.default,
            { className: 'material-icons' },
            'verified_user'
          );
      }
    }
  }, {
    key: 'getAvatarColor',
    value: function getAvatarColor(notificationType) {
      switch (notificationType) {
        case 'Success':
          return Colors.lightGreen400;
        case 'Error':
          return Colors.red500;
        case 'Info':
          return Colors.blue500;
        case 'Warning':
          return Colors.yellow800;
        default:
          return Colors.grey400;
      }
    }
  }, {
    key: 'closePopover',
    value: function closePopover() {
      var clearNotification = this.props.clearNotification;

      if (clearNotification) {
        clearNotification();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var anchorOrigin = { horizontal: 'right', vertical: 'bottom' };
      var targetOrigin = { horizontal: 'right', vertical: 'top' };
      var _props = this.props,
          notification = _props.notification,
          open = _props.open,
          anchorEl = _props.anchorEl;

      var style = this.getNotificationStyle();
      return _react2.default.createElement(
        _Popover2.default,
        {
          open: open,
          anchorEl: anchorEl,
          anchorOrigin: anchorOrigin,
          targetOrigin: targetOrigin,
          zDepth: 2,
          onRequestClose: this.closePopover,
          style: style
        },
        _react2.default.createElement(_List.ListItem, {
          disabled: true,
          leftAvatar: _react2.default.createElement(_Avatar2.default, {
            icon: this.getNotificationFontIcon(notification.type),
            backgroundColor: this.getAvatarColor(notification.type)
          }),
          primaryText: notification.type,
          secondaryText: notification.text,
          secondaryTextLines: 2
        })
      );
    }
  }]);

  return Notification;
}(_react2.default.Component);

exports.default = Notification;


Notification.propTypes = {
  open: _react2.default.PropTypes.bool,
  anchorEl: _react2.default.PropTypes.any,
  clearNotification: _react2.default.PropTypes.func,
  notification: _react2.default.PropTypes.object
};