'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _panel = require('./panel');

var _panel2 = _interopRequireDefault(_panel);

var _List = require('material-ui/List');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Shortlist = function (_React$Component) {
  _inherits(Shortlist, _React$Component);

  function Shortlist(props) {
    _classCallCheck(this, Shortlist);

    var _this = _possibleConstructorReturn(this, (Shortlist.__proto__ || Object.getPrototypeOf(Shortlist)).call(this, props));

    var list = props.list,
        value = props.value;

    _this.state = { list: _this.getUpdatedList(list, value), shortlist: value || [],
      selectedListItem: {}, selectedShortlistItem: {} };
    _this.onItemSelect = _this.onItemSelect.bind(_this);
    _this.onItemUnselect = _this.onItemUnselect.bind(_this);
    _this.moveUp = _this.moveUp.bind(_this);
    _this.moveDown = _this.moveDown.bind(_this);
    _this.indexOf = _this.indexOf.bind(_this);
    return _this;
  }

  _createClass(Shortlist, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var list = newProps.list,
          value = newProps.value;

      this.setState({ list: this.getUpdatedList(list, value), shortlist: value || [] });
    }
  }, {
    key: 'onItemSelect',
    value: function onItemSelect() {
      var _state = this.state,
          shortlist = _state.shortlist,
          selectedListItem = _state.selectedListItem,
          list = _state.list;

      if (!(0, _lodash.isEmpty)(selectedListItem)) {
        shortlist.push(selectedListItem);
        var index = list.indexOf(selectedListItem);
        list.splice(index, 1);
        this.setState({ selectedListItem: {} });
        var _props = this.props,
            onChange = _props.onChange,
            docField = _props.docField;

        onChange(docField, shortlist);
      }
    }
  }, {
    key: 'onItemUnselect',
    value: function onItemUnselect() {
      var _state2 = this.state,
          list = _state2.list,
          selectedShortlistItem = _state2.selectedShortlistItem,
          shortlist = _state2.shortlist;

      if (!(0, _lodash.isEmpty)(selectedShortlistItem)) {
        list.push(selectedShortlistItem);
        var index = shortlist.indexOf(selectedShortlistItem);
        shortlist.splice(index, 1);
        this.setState({ selectedShortlistItem: {} });
        var _props2 = this.props,
            onChange = _props2.onChange,
            docField = _props2.docField;

        onChange(docField, shortlist);
      }
    }
  }, {
    key: 'getUpdatedList',
    value: function getUpdatedList(list, shortlist) {
      var _this2 = this;

      if (shortlist) {
        var newList = list;
        shortlist.forEach(function (item) {
          var index = _this2.indexOf(newList, item);
          if (index >= 0) {
            newList.splice(index, 1);
          }
        });
        return newList;
      }
      return list;
    }
  }, {
    key: 'indexOf',
    value: function indexOf(arr, item) {
      var compareKey = this.props.compareKey;

      var givenItem = JSON.stringify(item);
      var index = -1;
      if (compareKey) {
        for (var i = 0; i < arr.length; i++) {
          var currentItem = arr[i];
          if (item[compareKey] === currentItem[compareKey]) {
            index = i;
            break;
          }
        }
      } else {
        for (var _i = 0; _i < arr.length; _i++) {
          var _currentItem = JSON.stringify(arr[_i]);
          if (_currentItem === givenItem) {
            index = _i;
            break;
          }
        }
      }
      return index;
    }
  }, {
    key: 'moveDown',
    value: function moveDown() {
      var _state3 = this.state,
          selectedShortlistItem = _state3.selectedShortlistItem,
          shortlist = _state3.shortlist;

      var index = shortlist.indexOf(selectedShortlistItem);
      if (!(0, _lodash.isEmpty)(selectedShortlistItem) && index < shortlist.length - 1) {
        shortlist.splice(index, 1);
        shortlist.splice(index + 1, 0, selectedShortlistItem);
        var _props3 = this.props,
            onChange = _props3.onChange,
            docField = _props3.docField;

        onChange(docField, shortlist);
      }
    }
  }, {
    key: 'moveUp',
    value: function moveUp() {
      var _state4 = this.state,
          selectedShortlistItem = _state4.selectedShortlistItem,
          shortlist = _state4.shortlist;

      var index = shortlist.indexOf(selectedShortlistItem);
      if (!(0, _lodash.isEmpty)(selectedShortlistItem) && index) {
        shortlist.splice(index, 1);
        shortlist.splice(index - 1, 0, selectedShortlistItem);
        var _props4 = this.props,
            onChange = _props4.onChange,
            docField = _props4.docField;

        onChange(docField, shortlist);
      }
    }
  }, {
    key: 'renderShortList',
    value: function renderShortList() {
      var _this3 = this;

      var _state5 = this.state,
          selectedShortlistItem = _state5.selectedShortlistItem,
          shortlist = _state5.shortlist;
      var displayKey = this.props.displayKey;

      return shortlist.map(function (item) {
        var isSelected = selectedShortlistItem === item;
        var style = isSelected ? { backgroundColor: 'lightskyblue' } : { backgroundColor: 'white' };
        var value = item[displayKey];
        return _react2.default.createElement(
          _List.ListItem,
          {
            key: value,
            style: style,
            onTouchTap: function onTouchTap() {
              var newItem = isSelected ? {} : item;
              _this3.setState({ selectedShortlistItem: newItem });
            }
          },
          value
        );
      });
    }
  }, {
    key: 'renderFullList',
    value: function renderFullList() {
      var _this4 = this;

      var _state6 = this.state,
          selectedListItem = _state6.selectedListItem,
          _state6$list = _state6.list,
          list = _state6$list === undefined ? [] : _state6$list;
      var displayKey = this.props.displayKey;

      return list.map(function (item) {
        var isSelected = selectedListItem === item;
        var style = isSelected ? { backgroundColor: 'lightskyblue' } : { backgroundColor: 'white' };
        var value = item[displayKey];
        return _react2.default.createElement(
          _List.ListItem,
          {
            key: value,
            style: style,
            onTouchTap: function onTouchTap() {
              var newItem = isSelected ? {} : item;
              _this4.setState({ selectedListItem: newItem });
            }
          },
          value
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          displayName = _props5.displayName,
          subtitle = _props5.subtitle;

      return _react2.default.createElement(
        _panel2.default,
        { title: displayName, subtitle: subtitle, zDepth: 1 },
        _react2.default.createElement(
          'div',
          { className: 'row middle-xs' },
          _react2.default.createElement(
            'div',
            { className: 'col-xs-5 col-lg-5 col-sm-5 col-md-5' },
            _react2.default.createElement(
              'div',
              { style: { paddingBottom: '1em' }, className: 'row center-xs' },
              'Available'
            ),
            _react2.default.createElement(
              _Paper2.default,
              { zDepth: 1, style: { height: 180, overflowY: 'auto' } },
              this.renderFullList()
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-xs-1 col-lg-1 col-sm-1 col-md-1' },
            _react2.default.createElement(
              'div',
              { className: 'row column-lg column-md column-sm' },
              _react2.default.createElement(
                'div',
                { className: 'row center-lg center-md center-sm ' },
                _react2.default.createElement(
                  _IconButton2.default,
                  {
                    style: { marginBottom: '1em' },
                    onTouchTap: this.onItemSelect,
                    iconClassName: 'material-icons'
                  },
                  'arrow_forward'
                )
              ),
              _react2.default.createElement(
                'div',
                { className: 'row center-lg center-md center-sm ' },
                _react2.default.createElement(
                  _IconButton2.default,
                  {
                    onTouchTap: this.onItemUnselect,
                    iconClassName: 'material-icons'
                  },
                  'arrow_back'
                )
              )
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-xs-5' },
            _react2.default.createElement(
              'div',
              { style: { paddingBottom: '1em' }, className: 'row center-xs' },
              'Selected'
            ),
            _react2.default.createElement(
              _Paper2.default,
              { zDepth: 1, style: { height: 180, overflowY: 'auto' } },
              this.renderShortList()
            )
          ),
          _react2.default.createElement(
            'div',
            { className: 'col-xs-1' },
            _react2.default.createElement(
              'div',
              { className: 'row middle-xs column-xs' },
              _react2.default.createElement(
                'div',
                { className: 'row center-xs' },
                _react2.default.createElement(
                  _IconButton2.default,
                  {
                    style: { marginBottom: '1em' },
                    onTouchTap: this.moveUp,
                    iconClassName: 'material-icons'
                  },
                  'arrow_upward'
                )
              ),
              _react2.default.createElement(
                'div',
                { className: 'row center-xs' },
                _react2.default.createElement(
                  _IconButton2.default,
                  {
                    onTouchTap: this.moveDown,
                    iconClassName: 'material-icons'
                  },
                  'arrow_downward'
                )
              )
            )
          )
        )
      );
    }
  }]);

  return Shortlist;
}(_react2.default.Component);

exports.default = Shortlist;


Shortlist.propTypes = {
  list: _react2.default.PropTypes.array,
  displayName: _react2.default.PropTypes.string,
  subtitle: _react2.default.PropTypes.string,
  value: _react2.default.PropTypes.any,
  docField: _react2.default.PropTypes.string,
  onChange: _react2.default.PropTypes.func.isRequired,
  displayKey: _react2.default.PropTypes.string,
  compareKey: _react2.default.PropTypes.string
};