'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Table = require('material-ui/Table');

var _actionButton = require('../action-button');

var _actionButton2 = _interopRequireDefault(_actionButton);

var _tableRowHeader = require('./table-row-header');

var _tableRowHeader2 = _interopRequireDefault(_tableRowHeader);

var _colors = require('material-ui/styles/colors');

var Colors = _interopRequireWildcard(_colors);

var _lodash = require('lodash');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SimpleRowActionTable = function (_React$Component) {
  _inherits(SimpleRowActionTable, _React$Component);

  function SimpleRowActionTable(props) {
    _classCallCheck(this, SimpleRowActionTable);

    var _this = _possibleConstructorReturn(this, (SimpleRowActionTable.__proto__ || Object.getPrototypeOf(SimpleRowActionTable)).call(this, props));

    _this.renderRowColumns = _this.renderRowColumns.bind(_this);
    _this.renderRow = _this.renderRow.bind(_this);
    _this.renderHeaders = _this.renderHeaders.bind(_this);
    return _this;
  }

  _createClass(SimpleRowActionTable, [{
    key: 'renderRowColumns',
    value: function renderRowColumns(row, fields) {
      var index = 0;
      return fields.map(function (field) {
        var tokens = (0, _lodash.split)(field, '.', 3);
        var value = row[tokens[0]];
        index += 1;
        for (var i = 1; i < tokens.length; i++) {
          value = value ? value[tokens[i]] : '';
        }
        return _react2.default.createElement(
          _Table.TableRowColumn,
          { key: index },
          value
        );
      });
    }
  }, {
    key: 'renderActions',
    value: function renderActions(row, actions) {
      if (!actions || actions.length === 0) return '';
      var actionsToShow = (0, _lodash.filter)(actions, function (action) {
        if (action.show) {
          return action.show(row);
        }
        return true;
      });
      var index = 0;
      return _react2.default.createElement(
        _Table.TableRowColumn,
        null,
        _react2.default.createElement(
          'div',
          { className: 'row' },
          actionsToShow.map(function (action) {
            return _react2.default.createElement(_actionButton2.default, {
              key: index++,
              type: action.type,
              onTouchTap: action.onTouchTap(row),
              style: { margin: '0.5em' },
              icon: action.icon,
              tooltip: action.tooltip
            });
          })
        )
      );
    }
  }, {
    key: 'renderRow',
    value: function renderRow() {
      var _this2 = this;

      var _props$data = this.props.data,
          rows = _props$data.rows,
          fields = _props$data.fields,
          actions = _props$data.actions;

      var index = 0;
      return rows.map(function (row) {
        return _react2.default.createElement(
          _Table.TableRow,
          { key: index++ },
          _this2.renderRowColumns(row, fields),
          _this2.renderActions(row, actions)
        );
      });
    }
  }, {
    key: 'renderHeaders',
    value: function renderHeaders() {
      var headers = this.props.data.headers;

      var index = 0;
      return _react2.default.createElement(
        _Table.TableRow,
        null,
        headers.map(function (header) {
          return _react2.default.createElement(
            _Table.TableHeaderColumn,
            { key: index++ },
            header.val
          );
        })
      );
    }
  }, {
    key: 'renderTitle',
    value: function renderTitle() {
      var _props$data2 = this.props.data,
          title = _props$data2.title,
          headers = _props$data2.headers;

      if (title) {
        var header = [{ val: title }];
        var style = {
          fontSize: 15,
          fontWeight: 600,
          color: Colors.darkBlack,
          backgroundColor: Colors.grey200
        };
        return _react2.default.createElement(_tableRowHeader2.default, { headers: header, colSpan: headers.length, style: style });
      }
      return '';
    }
  }, {
    key: 'render',
    value: function render() {
      var _props$data3 = this.props.data,
          headers = _props$data3.headers,
          height = _props$data3.height,
          _props$data3$fixedHea = _props$data3.fixedHeader,
          fixedHeader = _props$data3$fixedHea === undefined ? true : _props$data3$fixedHea,
          tableLayout = _props$data3.tableLayout;

      var tableLayoutVal = tableLayout || 'fixed';
      var tableOptions = {
        fixedHeader: fixedHeader,
        fixedFooter: true,
        stripedRows: true,
        showRowHover: true,
        selectable: false,
        multiSelectable: false,
        enableSelectAll: false,
        deselectOnClickaway: false,
        displayRowCheckbox: false,
        height: height || '200px'
      };
      return _react2.default.createElement(
        _Table.Table,
        _extends({}, tableOptions, { style: { tableLayout: tableLayoutVal } }),
        _react2.default.createElement(
          _Table.TableHeader,
          tableOptions,
          this.renderTitle(),
          _react2.default.createElement(_tableRowHeader2.default, { headers: headers })
        ),
        _react2.default.createElement(
          _Table.TableBody,
          tableOptions,
          this.renderRow()
        )
      );
    }
  }]);

  return SimpleRowActionTable;
}(_react2.default.Component);

exports.default = SimpleRowActionTable;


SimpleRowActionTable.propTypes = {
  data: _react2.default.PropTypes.object,
  height: _react2.default.PropTypes.any
};