'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Table = require('material-ui/Table');

var _actionButton = require('../action-button');

var _actionButton2 = _interopRequireDefault(_actionButton);

var _colors = require('material-ui/styles/colors');

var Colors = _interopRequireWildcard(_colors);

var _lodash = require('lodash');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SimpleTable = function (_React$Component) {
  _inherits(SimpleTable, _React$Component);

  function SimpleTable(props) {
    _classCallCheck(this, SimpleTable);

    var _this = _possibleConstructorReturn(this, (SimpleTable.__proto__ || Object.getPrototypeOf(SimpleTable)).call(this, props));

    _this.renderRowColumns = _this.renderRowColumns.bind(_this);
    _this.renderRow = _this.renderRow.bind(_this);
    _this.renderHeaders = _this.renderHeaders.bind(_this);
    _this.onRowSelection = _this.onRowSelection.bind(_this);
    _this.onActionClick = _this.onActionClick.bind(_this);
    _this.state = { selectedRows: [], selectedRowNumbers: [] };
    return _this;
  }

  _createClass(SimpleTable, [{
    key: 'onActionClick',
    value: function onActionClick(action) {
      if (action.onTouchTap) {
        action.onTouchTap(this.selectedRows);
      }
    }
  }, {
    key: 'onRowSelection',
    value: function onRowSelection(selection) {
      var rows = this.props.data.rows;

      if (selection === 'all') {
        this.selectedRows = rows;
      } else if ((0, _lodash.isArray)(selection)) {
        var selectedRows = selection.map(function (selectedIndex) {
          return rows[selectedIndex];
        });
        this.selectedRows = selectedRows;
      } else {
        this.selectedRows = [];
      }
    }
  }, {
    key: 'renderRowColumns',
    value: function renderRowColumns(row, fields) {
      var index = 0;
      return fields.map(function (field) {
        return _react2.default.createElement(
          _Table.TableRowColumn,
          { key: index++ },
          row[field]
        );
      });
    }
  }, {
    key: 'renderRow',
    value: function renderRow() {
      var _this2 = this;

      var _props$data = this.props.data,
          rows = _props$data.rows,
          fields = _props$data.fields;

      return rows.map(function (row, index) {
        return _react2.default.createElement(
          _Table.TableRow,
          { key: index },
          _this2.renderRowColumns(row, fields)
        );
      });
    }
  }, {
    key: 'renderTitleWithButton',
    value: function renderTitleWithButton() {
      var _this3 = this;

      var index = 0;
      var _props$data2 = this.props.data,
          title = _props$data2.title,
          actions = _props$data2.actions;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: { display: 'inline-block', float: 'left', color: Colors.darkBlack } },
          title
        ),
        _react2.default.createElement(
          'div',
          { style: { display: 'inline-block', float: 'right' } },
          actions.map(function (action) {
            var disabled = false;
            if (action.type !== 'ADD') {
              disabled = _this3.state.selectedRows.length === 0;
            }
            return _react2.default.createElement(_actionButton2.default, _extends({
              key: index++
            }, action, {
              onTouchTap: _this3.onActionClick.bind(_this3, action) // eslint-disable-line
              , style: { margin: '0.5em' },
              disabled: disabled
            }));
          })
        )
      );
    }
  }, {
    key: 'renderTitle',
    value: function renderTitle() {
      var headers = this.props.data.headers;

      return _react2.default.createElement(
        _Table.TableRow,
        null,
        _react2.default.createElement(
          _Table.TableHeaderColumn,
          { style: { fontSize: 20 }, colSpan: headers.length },
          this.renderTitleWithButton()
        )
      );
    }
  }, {
    key: 'renderHeaders',
    value: function renderHeaders() {
      var headers = this.props.data.headers;

      var index = 0;
      return _react2.default.createElement(
        _Table.TableRow,
        null,
        headers.map(function (header) {
          return _react2.default.createElement(
            _Table.TableHeaderColumn,
            { key: index++ },
            header.val
          );
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var tableOptions = {
        fixedHeader: true,
        fixedFooter: true,
        stripedRows: true,
        showRowHover: true,
        selectable: true,
        multiSelectable: false,
        enableSelectAll: false,
        deselectOnClickaway: false,
        displayRowCheckbox: true,
        height: '310px',
        style: { overflowX: 'auto' }
      };
      return _react2.default.createElement(
        _Table.Table,
        _extends({}, tableOptions, { onRowSelection: this.onRowSelection }),
        _react2.default.createElement(
          _Table.TableHeader,
          tableOptions,
          this.renderTitle(),
          this.renderHeaders()
        ),
        _react2.default.createElement(
          _Table.TableBody,
          tableOptions,
          this.renderRow()
        )
      );
    }
  }]);

  return SimpleTable;
}(_react2.default.Component);

exports.default = SimpleTable;


SimpleTable.propTypes = {
  data: _react2.default.PropTypes.any,
  title: _react2.default.PropTypes.string
};