'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _reactSimpleDi = require('react-simple-di');

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function isNullOrUndefined(x) {
  return !(x != null);
}

function composeWithRedux(ComposedComponent, FormName, formSchema) {
  var Container = function (_React$Component) {
    _inherits(Container, _React$Component);

    function Container(props, context) {
      _classCallCheck(this, Container);

      var _this = _possibleConstructorReturn(this, (Container.__proto__ || Object.getPrototypeOf(Container)).call(this, props, context));

      var formName = isNullOrUndefined(FormName) ? props.formName : FormName;
      _this.state = { formName: formName };
      _this.onChange = _this.onChange.bind(_this);
      _this.onAutoCompleteSelect = _this.onAutoCompleteSelect.bind(_this);
      return _this;
    }

    _createClass(Container, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        var FormState = this.props.FormState;
        /*
         * Here we will first copy the default data
         * then we will copy our props data that is coming
         * from outside onto it and set it inside our form
         * At this moment we are setting the data for
         * the first time.
         */

        if (isNullOrUndefined(this.state.formName)) {
          return;
        }
        var newFormData = {};
        (0, _lodash.extend)(newFormData, this.getFormWithDefaultValues());
        if (this.props.data) {
          (0, _lodash.extend)(newFormData, this.props.data);
        }
        FormState.initForm(newFormData, this.state.formName);
      }
    }, {
      key: 'getFormWithDefaultValues',
      value: function getFormWithDefaultValues() {
        var schema = this.props.formSchema;
        if (!schema) {
          schema = formSchema;
        }
        var form = {};
        if (schema) {
          (0, _lodash.forOwn)(schema, function (field) {
            if (field && field.defaultValue) {
              form[field.docField] = field.defaultValue;
            }
          });
        }
        return form;
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        var FormState = this.props.FormState;

        this.mounted = true;
        this.unsubscribe = FormState.observeStore(function (state) {
          return state.forms[_this2.state.formName];
        }, function (currentState) {
          if (_this2.mounted) {
            _this2.setState({ payload: currentState });
          }
        });
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(newProps) {
        var FormState = this.props.FormState;

        var formName = this.state.formName;
        if (isNullOrUndefined(this.state.formName)) {
          formName = isNullOrUndefined(FormName) ? this.props.formName : FormName;
          this.setState({ formName: formName });
        }
        /*
        * Here we are setting the default data first for the form
        * Then we are copying data already in the form onto it.
        * Then we replace new data that is coming from outside
        * onto it if there is any. Then we initialize the form
        * with it. This is not the first time we are setting the data.
        */
        var data = {};
        (0, _lodash.extend)(data, this.getFormWithDefaultValues());
        (0, _lodash.extend)(data, newProps.data);
        FormState.initForm(data, FormName);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unsubscribe();
        this.mounted = false;
        var FormState = this.props.FormState;

        FormState.deleteForm(this.state.formName);
      }
    }, {
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps, nextState) {
        var shouldUpdate = !(0, _shallowequal2.default)(this.props, nextProps);
        shouldUpdate = shouldUpdate || !(0, _shallowequal2.default)(this.state.payload, nextState.payload);
        return shouldUpdate;
      }
    }, {
      key: 'onAutoCompleteSelect',
      value: function onAutoCompleteSelect(field, value) {
        var FormState = this.props.FormState;

        FormState.formFieldChange(field, value, this.state.formName);
      }
    }, {
      key: 'onChange',
      value: function onChange(field, value) {
        var FormState = this.props.FormState;

        FormState.formFieldChange(field, value, this.state.formName);
      }
    }, {
      key: 'render',
      value: function render() {
        var _this3 = this;

        var FormState = this.props.FormState;

        var schema = this.props.formSchema;
        if (!schema) {
          schema = formSchema;
        }
        var currentState = FormState.getForm(this.state.formName);
        var newSchema = (0, _lodash.mapValues)(schema, function (val) {
          if (val.type === 'CODE_VALUE' || val.type === 'LIST' || val.type === 'AUTOCOMPLETE') {
            return _extends({}, val, {
              onChange: _this3.onChange,
              value: currentState[val.docField],
              onItemSelect: _this3.onAutoCompleteSelect });
          }
          return _extends({}, val, { onChange: _this3.onChange, value: currentState[val.docField] });
        });

        var newProps = (0, _lodash.omit)(this.props, ['data', 'store', 'initForm', 'deleteForm', 'observeStore', 'formFieldChange']);
        return _react2.default.createElement(ComposedComponent, _extends({}, newProps, newSchema, { currentState: currentState }));
      }
    }]);

    return Container;
  }(_react2.default.Component);

  Container.propTypes = {
    data: _react2.default.PropTypes.object,
    FormState: _react2.default.PropTypes.object,
    formSchema: _react2.default.PropTypes.any,
    formName: _react2.default.PropTypes.string
  };

  var depsToPropsMapper = function depsToPropsMapper(context) {
    return {
      FormState: context.FormState
    };
  };
  return (0, _reactSimpleDi.useDeps)(depsToPropsMapper)(Container);
}

exports.default = composeWithRedux;