'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.forms = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _formsActionTypes = require('./forms-action-types');

var _formsActionTypes2 = _interopRequireDefault(_formsActionTypes);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var changeFormField = function changeFormField(forms, payload) {
  var newFormData = _extends({}, forms[payload.form], _defineProperty({}, payload.field, payload.value));
  var newForms = _extends({}, forms, _defineProperty({}, payload.form, newFormData));
  return newForms;
};

var addValueToArrayField = function addValueToArrayField(forms, payload) {
  if (!payload.form && !payload.field && !payload.value && !(0, _lodash.isArray)(payload.field)) {
    return forms;
  }
  var form = forms[payload.form];
  var newArray = form[payload.field] ? [].concat(_toConsumableArray(form[payload.field]), [payload.value]) : [payload.value];
  return _extends({}, forms, _defineProperty({}, payload.form, _extends({}, forms[payload.form], _defineProperty({}, payload.field, newArray))));
};

var removeValueFromArrayField = function removeValueFromArrayField(forms, payload) {
  if (!payload.form && !payload.field && !payload.value && !(0, _lodash.isArray)(payload.field)) {
    return forms;
  }
  var form = forms[payload.form];
  var newArray = [].concat(_toConsumableArray(form[payload.field].slice(0, payload.value)), _toConsumableArray(form[payload.field].slice(payload.value + 1)));
  return _extends({}, forms, _defineProperty({}, payload.form, _extends({}, forms[payload.form], _defineProperty({}, payload.field, newArray))));
};

var addForm = function addForm(forms, payload) {
  return _extends({}, forms, _defineProperty({}, payload.form, payload.data));
};

var deleteFormFromState = function deleteFormFromState(forms, payload) {
  var newState = _extends({}, forms);
  if (newState[payload.form]) {
    delete newState[payload.form];
  }
  return newState;
};

var forms = exports.forms = function forms() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var action = arguments[1];

  switch (action.type) {
    case _formsActionTypes2.default.INIT_FORM:
      return addForm(state, action.payload);
    case _formsActionTypes2.default.FORM_FIELD_CHANGE:
      return changeFormField(state, action.payload);
    case _formsActionTypes2.default.ADD_VALUE_TO_ARRAY_FIELD:
      return addValueToArrayField(state, action.payload);
    case _formsActionTypes2.default.REMOVE_VALUE_FROM_ARRAY_FIELD:
      return removeValueFromArrayField(state, action.payload);
    case _formsActionTypes2.default.CLEAR_FORM:
      return addForm(state, action.payload);
    case _formsActionTypes2.default.DELETE_FORM:
      return deleteFormFromState(state, action.payload);
    default:
      return state;
  }
};