'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _formsActionCreators = require('./forms-action-creators.js');

var _formsActionCreators2 = _interopRequireDefault(_formsActionCreators);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FormState = function () {
  function FormState(store) {
    _classCallCheck(this, FormState);

    this.store = store;
  }

  _createClass(FormState, [{
    key: 'initForm',
    value: function initForm(formData, formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.initFormAction(formData, formName));
    }
  }, {
    key: 'formFieldChange',
    value: function formFieldChange(fieldName, fieldValue, formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.formFieldChangeAction(fieldName, fieldValue, formName));
    }
  }, {
    key: 'clearForm',
    value: function clearForm(formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.clearFormAction(formName));
    }
  }, {
    key: 'deleteForm',
    value: function deleteForm(formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.deleteFormAction(formName));
    }
  }, {
    key: 'addArrayField',
    value: function addArrayField(arrayField, valueToAdd, formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.addArrayFieldAction(arrayField, valueToAdd, formName));
    }
  }, {
    key: 'removeArrayField',
    value: function removeArrayField(arrayField, index, formName) {
      var dispatch = this.store.dispatch;

      dispatch(_formsActionCreators2.default.removeArrayFieldAction(arrayField, index, formName));
    }
  }, {
    key: 'observeStore',
    value: function observeStore(select, onChange) {
      var _this = this;

      var currentState = void 0;

      var handleChange = function handleChange() {
        var nextState = select(_this.store.getState());
        if (nextState !== currentState) {
          currentState = nextState;
          onChange(currentState);
        }
      };
      var unsubscribe = this.store.subscribe(handleChange);
      handleChange();
      return unsubscribe;
    }

    /**
     * Gets state from local store
     * @param {string} name - name of the state
     * @return {object} current state (full state if name is undefined or null)
     */

  }, {
    key: 'get',
    value: function get(name) {
      if (!name) {
        var state = this.store.getState();
        return state;
      }
      return this.store.getState()[name];
    }

    /**
     * Gets form state
     * @param {string} name - name of the form
     * @return {object} State of the form (All forms are returned if name is undefined/null)
     */

  }, {
    key: 'getForm',
    value: function getForm(name) {
      if (!name) {
        return this.store.getState().forms;
      }
      return this.store.getState().forms[name];
    }
  }]);

  return FormState;
}();

exports.default = FormState;