'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _formsActionTypes = require('./forms-action-types.js');

var _formsActionTypes2 = _interopRequireDefault(_formsActionTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  initFormAction: function initFormAction(formData, formName) {
    return { type: _formsActionTypes2.default.INIT_FORM, payload: { form: formName, data: formData } };
  },
  formFieldChangeAction: function formFieldChangeAction(fieldName, fieldValue, formName) {
    return { type: _formsActionTypes2.default.FORM_FIELD_CHANGE,
      payload: { form: formName, field: fieldName, value: fieldValue } };
  },
  clearFormAction: function clearFormAction(formName) {
    return { type: _formsActionTypes2.default.CLEAR_FORM, payload: { form: formName, data: {} } };
  },
  deleteFormAction: function deleteFormAction(formName) {
    return { type: _formsActionTypes2.default.DELETE_FORM, payload: { form: formName } };
  },
  addArrayFieldAction: function addArrayFieldAction(arrayField, valueToAdd, formName) {
    return { type: _formsActionTypes2.default.ADD_VALUE_TO_ARRAY_FIELD,
      payload: { form: formName, field: arrayField, value: valueToAdd } };
  },
  removeArrayFieldAction: function removeArrayFieldAction(arrayField, index, formName) {
    return { type: _formsActionTypes2.default.REMOVE_VALUE_FROM_ARRAY_FIELD,
      payload: { form: formName, field: arrayField, value: index } };
  }
};