(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var meteorInstall = Package['modules-runtime'].meteorInstall;

var require = meteorInstall({"node_modules":{"meteor":{"modules":{"server.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// packages/modules/server.js                                                         //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
require("./install-packages.js");
require("./process.js");
require("./reify.js");

////////////////////////////////////////////////////////////////////////////////////////

},"install-packages.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// packages/modules/install-packages.js                                               //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
function install(name, mainModule) {
  var meteorDir = {};

  // Given a package name <name>, install a stub module in the
  // /node_modules/meteor directory called <name>.js, so that
  // require.resolve("meteor/<name>") will always return
  // /node_modules/meteor/<name>.js instead of something like
  // /node_modules/meteor/<name>/index.js, in the rare but possible event
  // that the package contains a file called index.js (#6590).

  if (typeof mainModule === "string") {
    // Set up an alias from /node_modules/meteor/<package>.js to the main
    // module, e.g. meteor/<package>/index.js.
    meteorDir[name + ".js"] = mainModule;
  } else {
    // back compat with old Meteor packages
    meteorDir[name + ".js"] = function (r, e, module) {
      module.exports = Package[name];
    };
  }

  meteorInstall({
    node_modules: {
      meteor: meteorDir
    }
  });
}

// This file will be modified during computeJsOutputFilesMap to include
// install(<name>) calls for every Meteor package.

install("meteor");
install("meteor-base");
install("mobile-experience");
install("npm-mongo");
install("ecmascript-runtime");
install("modules-runtime");
install("modules", "meteor/modules/server.js");
install("modern-browsers", "meteor/modern-browsers/modern.js");
install("es5-shim");
install("promise", "meteor/promise/server.js");
install("ecmascript-runtime-client", "meteor/ecmascript-runtime-client/versions.js");
install("ecmascript-runtime-server", "meteor/ecmascript-runtime-server/runtime.js");
install("babel-compiler");
install("ecmascript");
install("babel-runtime", "meteor/babel-runtime/babel-runtime.js");
install("url", "meteor/url/url_server.js");
install("http", "meteor/http/httpcall_server.js");
install("dynamic-import", "meteor/dynamic-import/server.js");
install("base64", "meteor/base64/base64.js");
install("ejson", "meteor/ejson/ejson.js");
install("diff-sequence", "meteor/diff-sequence/diff.js");
install("geojson-utils", "meteor/geojson-utils/main.js");
install("id-map", "meteor/id-map/id-map.js");
install("random");
install("mongo-id", "meteor/mongo-id/id.js");
install("ordered-dict", "meteor/ordered-dict/ordered_dict.js");
install("tracker");
install("minimongo", "meteor/minimongo/minimongo_server.js");
install("check", "meteor/check/match.js");
install("retry", "meteor/retry/retry.js");
install("callback-hook", "meteor/callback-hook/hook.js");
install("ddp-common");
install("reload");
install("socket-stream-client", "meteor/socket-stream-client/node.js");
install("ddp-client", "meteor/ddp-client/server/server.js");
install("underscore");
install("rate-limit", "meteor/rate-limit/rate-limit.js");
install("ddp-rate-limiter");
install("logging", "meteor/logging/logging.js");
install("routepolicy", "meteor/routepolicy/main.js");
install("boilerplate-generator", "meteor/boilerplate-generator/generator.js");
install("webapp-hashing");
install("webapp", "meteor/webapp/webapp_server.js");
install("ddp-server");
install("ddp");
install("allow-deny");
install("binary-heap");
install("mongo");
install("session");
install("npm-bcrypt", "meteor/npm-bcrypt/wrapper.js");
install("accounts-base", "meteor/accounts-base/server_main.js");
install("sha");
install("srp");
install("email");
install("accounts-password");
install("reactive-dict", "meteor/reactive-dict/migration.js");
install("reactive-var");
install("kadira:flow-router");
install("shcherbin:flex-grid");
install("alanning:roles");
install("planettraining:material-design-icons-font");
install("standard-minifier-css");
install("standard-minifier-js");
install("dburles:factory");
install("shell-server", "meteor/shell-server/main.js");
install("coffeescript");
install("simple:json-routes");
install("nimble:restivus");
install("livedata");
install("hot-code-push");
install("launch-screen");
install("autoupdate");
install("service-configuration");

////////////////////////////////////////////////////////////////////////////////////////

},"process.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// packages/modules/process.js                                                        //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
if (! global.process) {
  try {
    // The application can run `npm install process` to provide its own
    // process stub; otherwise this module will provide a partial stub.
    global.process = require("process");
  } catch (missing) {
    global.process = {};
  }
}

var proc = global.process;

if (Meteor.isServer) {
  // Make require("process") work on the server in all versions of Node.
  meteorInstall({
    node_modules: {
      "process.js": function (r, e, module) {
        module.exports = proc;
      }
    }
  });
} else {
  proc.platform = "browser";
  proc.nextTick = proc.nextTick || Meteor._setImmediate;
}

if (typeof proc.env !== "object") {
  proc.env = {};
}

var hasOwn = Object.prototype.hasOwnProperty;
for (var key in meteorEnv) {
  if (hasOwn.call(meteorEnv, key)) {
    proc.env[key] = meteorEnv[key];
  }
}

////////////////////////////////////////////////////////////////////////////////////////

},"reify.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// packages/modules/reify.js                                                          //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
require("reify/lib/runtime").enable(
  module.constructor.prototype
);

////////////////////////////////////////////////////////////////////////////////////////

},"node_modules":{"reify":{"lib":{"runtime":{"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/meteor/modules/node_modules/reify/lib/runtime/index.js                //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}}}}}},"mqtt":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/mqtt/package.json                                                     //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "mqtt";
exports.version = "2.18.3";
exports.main = "mqtt.js";

////////////////////////////////////////////////////////////////////////////////////////

},"mqtt.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/mqtt/mqtt.js                                                          //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"lodash":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/lodash/package.json                                                   //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "lodash";
exports.version = "4.17.4";
exports.main = "lodash.js";

////////////////////////////////////////////////////////////////////////////////////////

},"lodash.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/lodash/lodash.js                                                      //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"winston":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/winston/package.json                                                  //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "winston";
exports.version = "2.4.0";
exports.main = "./lib/winston";

////////////////////////////////////////////////////////////////////////////////////////

},"lib":{"winston.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/winston/lib/winston.js                                                //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"moment":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/moment/package.json                                                   //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "moment";
exports.version = "2.19.3";
exports.main = "./moment.js";

////////////////////////////////////////////////////////////////////////////////////////

},"moment.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/moment/moment.js                                                      //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"joi-browser":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/joi-browser/package.json                                              //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "joi-browser";
exports.version = "10.6.1";
exports.main = "./dist/joi-browser.js";

////////////////////////////////////////////////////////////////////////////////////////

},"dist":{"joi-browser.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/joi-browser/dist/joi-browser.js                                       //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"amqplib":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/amqplib/package.json                                                  //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "amqplib";
exports.version = "0.5.2";
exports.main = "./channel_api.js";

////////////////////////////////////////////////////////////////////////////////////////

},"channel_api.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/amqplib/channel_api.js                                                //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"@babel":{"runtime":{"helpers":{"builtin":{"interopRequireDefault.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/@babel/runtime/helpers/builtin/interopRequireDefault.js               //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

},"objectSpread.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/@babel/runtime/helpers/builtin/objectSpread.js                        //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

},"objectWithoutProperties.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/@babel/runtime/helpers/builtin/objectWithoutProperties.js             //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"package.json":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/@babel/runtime/package.json                                           //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"deep-diff":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/deep-diff/package.json                                                //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "deep-diff";
exports.version = "0.3.8";
exports.main = "./index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/deep-diff/index.js                                                    //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"apconic-mqtt-commons":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/apconic-mqtt-commons/package.json                                     //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "apconic-mqtt-commons";
exports.version = "1.4.1";
exports.main = "lib/index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"lib":{"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/apconic-mqtt-commons/lib/index.js                                     //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"oracledb":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/oracledb/package.json                                                 //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "oracledb";
exports.version = "2.3.0";
exports.main = "./index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/oracledb/index.js                                                     //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"node-rfc":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/node-rfc/package.json                                                 //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "node-rfc";
exports.version = "0.1.16";
exports.main = "index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/node-rfc/index.js                                                     //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"uuid-lib":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/uuid-lib/package.json                                                 //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "uuid-lib";
exports.version = "0.0.6";
exports.main = "uuid-lib";

////////////////////////////////////////////////////////////////////////////////////////

},"uuid-lib.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/uuid-lib/uuid-lib.js                                                  //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"mssql":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/mssql/package.json                                                    //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "mssql";
exports.version = "4.1.0";
exports.main = "index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/mssql/index.js                                                        //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"lockfile":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/lockfile/package.json                                                 //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "lockfile";
exports.version = "1.0.3";
exports.main = "lockfile.js";

////////////////////////////////////////////////////////////////////////////////////////

},"lockfile.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/lockfile/lockfile.js                                                  //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"validator":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/validator/package.json                                                //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "validator";
exports.version = "7.2.0";
exports.main = "index.js";

////////////////////////////////////////////////////////////////////////////////////////

},"index.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/validator/index.js                                                    //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}},"nodemailer":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/nodemailer/package.json                                               //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "nodemailer";
exports.version = "4.6.8";
exports.main = "lib/nodemailer.js";

////////////////////////////////////////////////////////////////////////////////////////

},"lib":{"nodemailer.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/nodemailer/lib/nodemailer.js                                          //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}},"bcrypt":{"package.json":function(require,exports){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/bcrypt/package.json                                                   //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
exports.name = "bcrypt";
exports.version = "1.0.3";
exports.main = "./bcrypt";

////////////////////////////////////////////////////////////////////////////////////////

},"bcrypt.js":function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////
//                                                                                    //
// node_modules/bcrypt/bcrypt.js                                                      //
//                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////
                                                                                      //
module.useNode();
////////////////////////////////////////////////////////////////////////////////////////

}}}},{
  "extensions": [
    ".js",
    ".json"
  ]
});
var exports = require("/node_modules/meteor/modules/server.js");

/* Exports */
Package._define("modules", exports, {
  meteorInstall: meteorInstall
});

})();
